Package org.apache.storm.topology

# Class StatefulBoltExecutor<T extends State>

java.lang.Object
org.apache.storm.topology.BaseStatefulBoltExecutor
org.apache.storm.topology.StatefulBoltExecutor<T>

All Implemented Interfaces:
  `Serializable`, `IBolt`, `IComponent`, `IRichBolt`

public class StatefulBoltExecutor<T extends State> extends BaseStatefulBoltExecutor
Wraps a `IStatefulBolt` and manages the state of the bolt.

See Also:
  - Serialized Form

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class org.apache.storm.topology.BaseStatefulBoltExecutor

  `BaseStatefulBoltExecutor.AnchoringOutputCollector`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `StatefulBoltExecutor(IStatefulBolt<T> bolt)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `cleanup()`
  Called when an IBolt is going to be shutdown.
  `void`
  `declareOutputFields(OutputFieldsDeclarer declarer)`
  Declare the output schema for all the streams of this topology.
  `Map<String,Object>`
  `getComponentConfiguration()`
  Declare configuration specific to this component.
  `protected void`
  `handleCheckpoint(Tuple checkpointTuple, CheckPointState.Action action, long txid)`
  Sub-classes can implement the logic for handling checkpoint tuple.
  `protected void`
  `handleTuple(Tuple input)`
  Sub-classes can implement the logic for handling the tuple.
  `void`
  `prepare(Map<String,Object> topoConf, TopologyContext context, OutputCollector collector)`
  Called when a task for this component is initialized within a worker on the cluster.

  ### Methods inherited from class org.apache.storm.topology.BaseStatefulBoltExecutor

  `declareCheckpointStream, execute, init`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### StatefulBoltExecutor

    public StatefulBoltExecutor(IStatefulBolt<T> bolt)

- ## Method Details

  - ### prepare

    public void prepare(Map<String,Object> topoConf, TopologyContext context, OutputCollector collector)
    Description copied from interface: `IBolt`
    Called when a task for this component is initialized within a worker on the cluster. It provides the bolt with the environment in which the bolt executes.

    This includes the:

    Parameters:
      `topoConf` - The Storm configuration for this bolt. This is the configuration provided to the topology merged in with cluster configuration on this machine.
      `context` - This object can be used to get information about this task's place within the topology, including the task id and component id of this task, input and output information, etc.
      `collector` - The collector is used to emit tuples from this bolt. Tuples can be emitted at any time, including the prepare and cleanup methods. The collector is thread-safe and should be saved as an instance variable of this bolt object.

  - ### cleanup

    public void cleanup()
    Description copied from interface: `IBolt`
    Called when an IBolt is going to be shutdown. Storm will make a best-effort attempt to call this if the worker shutdown is orderly. The `Config.SUPERVISOR_WORKER_SHUTDOWN_SLEEP_SECS` setting controls how long orderly shutdown is allowed to take. There is no guarantee that cleanup will be called if shutdown is not orderly, or if the shutdown exceeds the time limit.

    The one context where cleanup is guaranteed to be called is when a topology is killed when running Storm in local mode.

  - ### declareOutputFields

    public void declareOutputFields(OutputFieldsDeclarer declarer)
    Description copied from interface: `IComponent`
    Declare the output schema for all the streams of this topology.
    Parameters:
      `declarer` - this is used to declare output stream ids, output fields, and whether or not each output stream is a direct stream

  - ### getComponentConfiguration

    public Map<String,Object> getComponentConfiguration()
    Description copied from interface: `IComponent`
    Declare configuration specific to this component. Only a subset of the "topology.*" configs can be overridden. The component configuration can be further overridden when constructing the topology using `TopologyBuilder`

  - ### handleCheckpoint

    protected void handleCheckpoint(Tuple checkpointTuple, CheckPointState.Action action, long txid)
    Description copied from class: `BaseStatefulBoltExecutor`
    Sub-classes can implement the logic for handling checkpoint tuple.
    Specified by:
      `handleCheckpoint` in class `BaseStatefulBoltExecutor`
    Parameters:
      `checkpointTuple` - the checkpoint tuple
      `action` - the action (prepare, commit, rollback or initstate)
      `txid` - the transaction id.

  - ### handleTuple

    protected void handleTuple(Tuple input)
    Description copied from class: `BaseStatefulBoltExecutor`
    Sub-classes can implement the logic for handling the tuple.
    Specified by:
      `handleTuple` in class `BaseStatefulBoltExecutor`
    Parameters:
      `input` - the input tuple